/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	navapi
//	変更履歴
//		2004.02.01	新規作成
//

import java.applet.Applet;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.Hashtable;

/**
 *	navapi クラス<br>
 *	SCOからのナビゲーションを行うクラス<br>
 */
public class navapi extends Applet {

	/** エンジンへのURL */
	private String engineURL;

	/**
	 * デフォルトコンストラクタ
	 */
	public navapi() {}

	/**
	 * アプレットの初期化
	 */
	public void init() {
		engineURL = getParameter("URL");
	}

	/**
	 * 値を取得する
	 *
	 * @param	dataModelName	取得するデータモデルのデータモデル名を指定する
	 * @param	parameter		URIを指定する
	 * @return	ハッシュテーブルを返却する。キー値は以下の通り
	 *			"ErrorCode"		エラーコードが設定される
	 *			"Result"		処理結果が設定される。
	 */
	public Hashtable getValue(String dataModelName, String parameter)
		throws IOException, ClassNotFoundException {

		Hashtable sendParameter = new Hashtable();

		sendParameter.put("Method", "GetValue");
		sendParameter.put("DataModel", dataModelName);
		if (parameter != null) {
			sendParameter.put("Parameter", parameter);
		}

		return transact(sendParameter);
	}

	/**
	 * 値を設定する
	 *
	 * @param	dataModelName	設定するデータモデルのデータモデル名を指定する
	 * @param	parameter1		データモデルに設定する値を指定する
	 * @param	parameter2		URIを指定する
	 * @return	ハッシュテーブルを返却する。キー値は以下の通り
	 *			"ErrorCode"		エラーコードが設定される
	 *			"NextURL"		正常終了時("ErrorCode"が"0"かつ、"Result"が"true"の場合)のみ有効、
	 *							次に遷移すべきURLが設定される
	 *			"Result"		処理結果が設定される。
	 */
	public Hashtable setValue(String dataModelName, String parameter1, String parameter2)
		throws IOException, ClassNotFoundException {

		Hashtable sendParameter = new Hashtable();

		sendParameter.put("Method", "SetValue");
		sendParameter.put("DataModel", dataModelName);
		sendParameter.put("Parameter1", parameter1);
		if (parameter2 != null) {
			sendParameter.put("Parameter2", parameter2);
		}

		return transact(sendParameter);
	}

	/**
	 * 送受信を行う
	 *
	 * @param	sendParameter	送信するHashtableを指定する
	 * @return	受信したHashtableを返却する
	 */
	private Hashtable transact(Hashtable sendParameter) throws IOException, ClassNotFoundException {
		URLConnection uc = new URL(engineURL).openConnection();

		uc.setDoOutput(true);
		uc.setUseCaches(false);
		uc.setRequestProperty("Content-Type", "application/octet-stream");

		uc.setDoInput(true);

		ObjectOutputStream oos = null;
		ObjectInputStream ois = null;

		try {
			oos = new ObjectOutputStream(uc.getOutputStream());
			oos.writeObject(sendParameter);

			ois = new ObjectInputStream(uc.getInputStream());
			return (Hashtable)ois.readObject();
		}
		finally {
			if (oos != null) {
				try {
					oos.close();
				}
				catch (Exception ex) {
					ex.printStackTrace(System.out);
				}
			}

			if (ois != null) {
				try {
					ois.close();
				}
				catch (Exception ex) {
					ex.printStackTrace(System.out);
				}
			}
		}
	}
}
